# Function based on http://rosettacode.org/wiki/Mandelbrot_set#R
iterate.until.escape <- function(remin, remax, immin, immax, delta, trans, cond, max=50, response=dwell) {
  #we iterate all active points in the same array operation,
  #and keeping track of which points are still iterating.
  
  re <- seq(remin, remax, delta)[-1]
  im <- seq(immin, immax, delta)[-1]
  c <- outer(re, im, function(x,y) complex(real=x, imaginary=y))
  
  z <- array(0, dim(c))
  active <- seq_along(z)
  dwell <- z
  dwell[] <- 0
  for (i in 1:max) {
    z[active] <- trans(z[active], c[active]);
    survived <- cond(z[active])
    dwell[active[!survived]] <- i
    active <- active[survived]
    if (length(active) == 0) break
  }
  eval(substitute(response))
}
